;================================================
;  INT 21  services
;================================================
Dexit		equ 4ch	; exit process
Dputc		equ 2	; put char in dl to stdout
Dmemmodify	equ 4ah ; modify allocated memory
Dprint		equ 9	; print string
Dmemalloc	equ 48h	; alloc dos memory
Dmemfree	equ 49h ; free dos memory
Dopen		equ 3dh ; Open disk file with handle
Dread		equ 3fh	; Read from disk file with handle
Dclose		equ 3eh ; Close disk file with handle
Dcreate		equ 3ch ; Create a new file with handle
Dwrite		equ 40h	; Write to file with handle
Dgetver		equ 30h	; Get DOS version

;================================================
; Align code to 256-byte page
;		(for .com files, where Start=100h)
;   syntax: @align100
;================================================
@align100 macro
	org ((($-Start+100h-1) shr 8) +1) shl 8
	endm

;================================================
; Align code to 16-byte page
;   syntax: @align10
;================================================
@align10 macro
	org ((($-Start+100h-1) shr 4) +1) shl 4
	endm

;================================================
; Align code to word (2 byte) page
;		(for .com files, where Start=100h)
;   syntax: @align2
;================================================
@align2	macro
        if (($-Start)/2) NE (($-Start+1)/2) 
        nop
        endif
	endm


;================================================
; Call of int 21h
;   syntax: @doscall func_no
;================================================
@doscall MACRO funcnum
	mov ah,funcnum
	int 21h
        endm

;================================================
; Release memory after loading .COM file
;================================================
@cominit macro
	mov bx,1000h
        @doscall Dmemmodify
        endm

;===================================
;  Print a message:
;    syntax: @print 'Mystring'
;===================================
@print	macro string
	call __print
        db string,0
	endm
;===================================
;  Print a message from next line:
;    syntax: @lnprint 'Mystring'
;===================================
@lnprint macro string,nl
	call __lnp
        db string,0
	endm

